InspectFix = CreateFrame("Button", "InspectFixHiddenFrame", UIParent)

local BlizzardNotifyInspect = _G.NotifyInspect
local InspectPaperDollFrame_SetLevel = nil
local loaded = false
local hooked = false

local lastunit
local function unitchange(self)
  local unit = self.unit
  if loaded and unit and unit ~= lastunit then
    lastunit = unit
    BlizzardNotifyInspect(unit)
    InspectFrame_UnitChanged(InspectFrame)
  end
end

local function NIhook(unit)
  InspectFix:tryhook()
  if InspectFrame and InspectFrame:IsVisible() then
    local str = debugstack(2)
    --print(str)
    local addon = string.match(str,'[%s%c]+([^:%s%c]*)\\[^\\:%s%c]+:')
    addon = string.gsub(addon or "unknown",'I?n?t?e?r?f?a?c?e\\AddOns\\',"")
    if not string.find(str,"Blizzard_InspectUI") then
      print("InspectFix blocked NotifyInspect from "..addon)
      return
    end
  end
  BlizzardNotifyInspect(unit)
end

local function setlevel_hook()
  if InspectFrame and InspectFrame.unit then
    return InspectPaperDollFrame_SetLevel()
  end
end

function InspectFix:tryhook()
  if false and not hooked and InspectFrame_UnitChanged then
    hooksecurefunc("InspectFrame_UnitChanged", unitchange)
    hooked = true
    print("InspectFix hook activated.")
  end
  if _G.InspectPaperDollFrame_SetLevel and _G.InspectPaperDollFrame_SetLevel ~= setlevel_hook then
    InspectPaperDollFrame_SetLevel = _G.InspectPaperDollFrame_SetLevel
    _G.InspectPaperDollFrame_SetLevel = setlevel_hook
  end
end
function InspectFix_OnEvent(event)
  if event == "ADDON_LOADED" then
    InspectFix:tryhook()
  end
end
InspectFix:SetScript("OnEvent", InspectFix_OnEvent)
InspectFix:RegisterEvent("ADDON_LOADED")

function InspectFix:Load()
  _G.NotifyInspect = NIhook
  InspectFix:tryhook()
  loaded = true
  print("InspectFix loaded.")
end

function InspectFix:Unload()
  _G.NotifyInspect = BlizzardNotifyInspect
  loaded = false
  print("InspectFix unloaded.")
end

InspectFix:Load()

SLASH_INSPECTFIX1 = "/inspectfix"
SLASH_INSPECTFIX2 = "/if"
SlashCmdList["INSPECTFIX"] = function(msg)
        local cmd = msg:lower()
        if cmd == "load" or cmd == "on" then
          InspectFix:Load()
        elseif cmd == "unload" or cmd == "off" then
          InspectFix:Unload()
        else
          print("/inspectfix [ on | off ]")
        end
end
